import MuseScore 3.0
import QtQuick 2.0

MuseScore {

    version: "1.0";
    description: "This demo plugin adds new chords\n\n" +
                 "Comments, feedbacks, report bugs, ask for new features, contribute:\n" +
                 "https://github.com/rousselmanu/msc_plugins/";
    menuPath: "Plugins.Chords." + qsTr("Add Chord Demo")
       
    
   
    
    
    function setCursorToTime(cursor, time){
        cursor.rewind(0);
        while (cursor.segment) { 
            var current_time = cursor.tick;
            if(current_time>=time){
                return true;
            }
            cursor.next();
        }
        cursor.rewind(0);
        return false;
    }// end setcursor To Time
	
    function addChord(cursor, chord_notes, duration){ 
		for (var c = 0; c < chord_notes.length; c++){
			//console.log("chord_notes = ", chord_notes[c]);
		}
		if(chord_notes.length==0) return -1;
		var cur_time=cursor.tick;
		cursor.setDuration(duration, 1920);
		cursor.addNote(chord_notes[0]); //add 1st note
		
		var next_time=cursor.tick;
		setCursorToTime(cursor, cur_time); //rewind to this note
		var note = cursor.element.notes[0];
		note.tpc = chord_notes[4];
		
		var chord = cursor.element; //get the chord created when 1st note was inserted
				
		for(var i=1; i<4; i++){
			var note = createNote(chord_notes[i], chord_notes[i+4]);
			//console.log("note.pitch = ", note.pitch, "note.tpc = ", note.tpc);
			note.tpc = chord_notes[i+4];
			chord.add(note); //add notes to the chord
			chord.notes[i].tpc = chord_notes[i+4];
		}
		
		setCursorToTime(cursor, next_time);
		return 0;
	}//end AddChord
	
    
    
    onRun: {
        if (typeof curScore === 'undefined') {
            Qt.quit();
        }

        var cursor = curScore.newCursor(),
                startStaff,
                endStaff,
                endTick,
                fullScore = false;
                
        cursor.rewind(1);
        

        if (!cursor.segment) { // no selection
            fullScore = true;
            startStaff = 0; // start with 1st staff
            endStaff = curScore.nstaves - 1; // and end with last
        } else {
            startStaff = cursor.staffIdx;
            cursor.rewind(2);
            if (cursor.tick === 0) {
                // this happens when the selection includes
                // the last measure of the score.
                // rewind(2) goes behind the last segment (where
                // there's none) and sets tick=0
                endTick = curScore.lastSegment.tick + 1;
            } else {
                endTick = cursor.tick;
            }
            endStaff = cursor.staffIdx;
        }
        console.log(startStaff + " - " + endStaff + " - " + endTick);
        console.log('curScore.nstaves: ' + curScore.nstaves);
        console.log('cursor.tick: ' + cursor.tick);
        console.log('curScore.lastSegment.tick: ' + curScore.lastSegment.tick);

        cursor.rewind(1); // beginning of selection
        if (fullScore) { // no selection
            cursor.rewind(0); // beginning of score
        }
        //cursor.voice = 0;
        
		console.log('cursor.staffIdx: ' + cursor.staffIdx);
		
        //cursor.track = 0;
        
		
		//cursor.staffIdx = 1;
		
		var mynotes = [
["c",72,14],
["d",74,16],
["e",76,18],
["e",76,18],
["f",77,13],
["g",79,15],
["b",83,19],
["c",72,14],
["c",60,14],
["d",62,16],
["f",65,13],
["g",67,15],
["g",67,15],
["gb",66,8],
["f",65,13],
["a#",70,24],
];
		
		//console.log('chords[0][2] = ' + chords[0][2]);
        cursor.staffIdx = 0;
		for (var c = 0; c < mynotes.length; c++) {

            var cur_time=cursor.tick;
            
            var cur_time=cursor.tick;
		    cursor.setDuration(320, 1920);
		    cursor.addNote(mynotes[c][1]); //add 1st note
            //addChord(cursor, chord, 480);
            var next_time=cursor.tick;

            //setCursorToTime(cursor, cur_time); //rewind to this note
		    //var thisnote = cursor.element.notes[0];
		    //thisnote.tpc = mynotes[c][3];
            setCursorToTime(cursor, next_time);
            
			
		}
		Qt.quit();
    } // end onRun
}
